; LoRa  GPS  spi+uart
.device Attiny13A
.include "tn13def.inc"	;Attiny13A, 1
;!  Attiny13    
;R.: PB0/1=20R; PB2/3/4=28R; PB5=32R


;GPS
.equ data_gps=5	;data in UART GPS
.equ pwr_gps=3	; GPS,
.equ ddrGPS=ddrB
.equ portGPS=portB
.equ pinGPS=pinB
;LoRa
.equ lora_nss=4	;nSEL,NSS,. ,=.1
.equ lora_sck=2	;SCK,
.equ lora_mosi=0;SDI,MOSI,    
.equ lora_miso=1;SDO,MISO,    
.equ ddrLoRa=ddrB
.equ portLoRa=portB
.equ pinLora=pinB


.org 0				; 
	rjmp start


.dseg
.org SRAM_Start
gps_: .byte 5+5;hex(chr)
.cseg


start:
;===================
ldi R16, RAMEND ;
out SPL, R16
;==== ====
; GPS+LoRa
ldi R16,(0<<7)|(0<<6)|(1<<pwr_gps)|(0<<data_gps)|(1<<lora_nss)|(1<<lora_sck)|(1<<lora_mosi)|(0<<lora_miso)
out ddrGPS,R16
ldi R16,(0<<7)|(0<<6)|(1<<pwr_gps)|(0<<data_gps)|(1<<lora_nss)|(0<<lora_sck)|(0<<lora_mosi)|(1<<lora_miso)
out portGPS,R16
;================
;R5R6R7-frequency
;frequency*61=Hz
ldi R16,0x6C	;H
mov R5,R16
ldi R16,0x0F	;M
mov R6,R16
ldi R16,0xF0	;L
mov R7,R16
clr R8			;ADC
clr R20			;   
clr R21			;  GPS,8.
clr R22			;speed,dec
;======wachdog======
ldi R16, 0b00010000	;WDCE
out WDTCR, R16
ldi R16, 0b00111001	;wachdog,5
out WDTCR, R16
;==  ,   ==




main:
wdr				;

rcall lora_preconfig; 

;rjmp gps	;test

rcall lora_search;signal search
;CAD  62,SF12=120ms,SF11=58ms,SF10=28ms
sbrs R17,0		;  
rjmp _sleep		; 
;   ,
;   

; 
ldi R16,0x39
ldi R17,0x34
rcall spi_write	;R16-,R17-
; ,  FIFO
ldi R16,0x22
ldi R17,12		;  
rcall spi_write	;R16-,R17-
;  
ldi R16,0x1f
ldi R17,50		;def=100,(sf12)50=3.2c,(sf11)50=1.6c
rcall spi_write	;R16-,R17-

zapros_otvet:
rcall lora_rx	;RX mode ON
rcall lora_rssi	;RSSI PowerTx

;  
clr R19
radio_clr:
wdr				;
rcall lora_search
sbrs R17,0		;
inc R19
sbrc R17,0		;
clr R19
cpi R19,10		;10 
brlo radio_clr
;-  

; 
ldi R16,0x09
mov R17,R10		;min=0x80;max=0x8F
;ldi R17,0x8F	;min=0x80;max=0x8F
rcall spi_write	;R16-,R17-
;   FIFO  TX
ldi R16,0x0e	;FiFoTxBaseAddr
ldi R17,0x00
rcall spi_write	;R16-,R17-
;    FIFO
ldi R16,0x0d	;SPI Pointer
ldi R17,0x00
rcall spi_write	;R16-,R17-
; FIFO
clr R16
mov R17,R11
rcall spi_write	;R16-,R17-
;end FIFO
ldi R16,0x0e	;FiFoTxBaseAddr
rcall spi_read	;R16-,R17-
ldi R16,0x0d	;SPI pointer
rcall spi_write	;R16-,R17-

;***TX mode ON***
rcall lora_tx
wdr				;




GPS:
wdr				;
sbi PortGPS,data_gps;
cbi PortGPS,pwr_gps	;gps power on, 

;    
rcall lora_search;signal search
sbrc R17,0		; ,  
rjmp zapros_otvet;  GPS

;  GPS UART
;  
ldi Yl,low(gps_)
ldi Yh,high(gps_)
ldi R16,'-'
ldi R17,5+5		;"----------"
gps_clr:		; 
st Y+,R16
dec R17		;-1
brne gps_clr

;    
;    UART
clr R18
before:
wdr				;
ldi R16,high(5)
ldi R17,low(5)
rcall delay		;25,1/4 
sbis PinGPS,data_gps;    "0"
clr R18			;.  
inc R18			;+1 .1
cpi R18,80		;20   .1
brlo before		; ,
;    .1 


;     
_s:
rcall uart_read
cpi R19,'V'
brne _s
rcall uart_read
cpi R19,'T'
brne _s
rcall uart_read
cpi R19,'G'
brne _s
;  ,   $GPVTG
;  , 
rcall zapyataja	;
rcall zapyataja	; 
rcall zapyataja
rcall zapyataja	; 
rcall zapyataja	;/
rcall zapyataja	; N
rcall zapyataja	;/
clr R22
rcall uart_read
cpi R19,'0'	;0km/h
brlo end_speed
;9
subi R19,'0'	;chr>>dec
mov R22,R19
rcall uart_read
cpi R19,'0'	;<10km/h
brlo end_speed
;99
rcall x10		;R22*10=R22
subi R19,'0'	;chr>>dec
add R22,R19		;99
rcall uart_read
cpi R19,'0'
brlo end_speed
;max255km/h
rcall x10		;R22*10=R22
subi R19,'0'	;chr>>dec
add R22,R19
end_speed:


;     
search:
rcall uart_read
cpi R19,'G'
brne search
rcall uart_read
cpi R19,'G'
brne search
rcall uart_read
cpi R19,'A'
brne search
;  ,   $GPGGA
;  , 
ldi Yl,low(gps_)
ldi Yh,high(gps_)
rcall zapyataja	;1,time
rcall zapyataja	;2,gps_n
rcall uart_read	;  
cpi R19,','		; 
breq end_n		; ,.
rcall gps_nesw	;  
end_n:		;3

rcall zapyataja;4,gps_e
rcall uart_read
cpi R19,','
breq end_e
rcall uart_read	;  
rcall gps_nesw
end_e:		;5

rcall zapyataja	;6,status_gps
rcall uart_read	;R19-data
cpi R19,'1'		; "1",  
breq _g2
rjmp GPS		; "0", 
_g2:
inc R21			;+1   
cpi R21,5
brsh gps_end	; 4
rjmp gps		; , 
gps_end:
clr R21			;.  
cbi PortGPS,data_gps;
sbi PortGPS,pwr_gps	;gps power off, 
; ,22 



;ADC
;     LoRa,stdby mode
cbi ddrGPS,lora_sck	;.
ldi R16, 0b01000001	;AD_Converter ADMUX byte
out ADMUX,R16
ldi R16, 0b11000011	;AD_Converter ADCSRA byte,125kHz
out ADCSRA,R16		; 
waiting_adc:
sbic ADCSRA,ADSC	;if Pb,n='1' then do
rjmp waiting_adc	;  ,0.2
in R8,ADCL			;. 
clr R16
out ADCSRA,R16		;.  
sbi ddrGPS,lora_sck	;.



; TX
wdr				;
; 
ldi R16,0x39
ldi R17,0x34
rcall spi_write	;R16-,R17-
; 
ldi R16,0x09
mov R17,R10		;min=0x80;max=0x8F
;ldi R17,0x8F	;min=0x80;max=0x8F
rcall spi_write	;R16-,R17-
; ,  FIFO
ldi R16,0x22
ldi R17,5+5+2	;+++
rcall spi_write	;R16-,R17-
;   FIFO  TX
ldi R16,0x0e	;FiFoTxBaseAddr
ldi R17,0x00
rcall spi_write	;R16-,R17-
;    FIFO
ldi R16,0x0d	;SPI Pointer
ldi R17,0x00
rcall spi_write	;R16-,R17-

; FIFO
ldi Xl,low(gps_)
ldi Xh,high(gps_)
ldi R19,5+5		;-
clr R16
_n:
ld R17,X+
rcall spi_write	;R16-,R17-
dec R19			;-1
brne _n
;+.,
mov R17,R22		;
rcall spi_write	;R16-,R17-
;+., 
mov R17,R8		;
rcall spi_write	;R16-,R17-
;end FIFO

ldi R16,0x0e	;FiFoTxBaseAddr
rcall spi_read	;R16-,R17-
ldi R16,0x0d	;SPI pointer
rcall spi_write	;R16-,R17-

;***TX mode ON***
rcall lora_tx

;   Call=Auto
;    TX,   
;  
ldi R16,0x1f
ldi R17,65		;def=100,(sf12)50=3.2c,(sf11)50=1.6c
rcall spi_write	;R16-,R17-
rcall lora_rx	;RX mode ON
	sbrc R17,4	;if bitX,n='1' then do
	clr R20		; ,  .Auto
; 
sbrc R17,4	;  RX,   
rcall lora_rssi	;RSSI +PowerTx
;GPS+    
inc R20			;+1. 
cpi R20,4		; =GPS*1
brsh _sleep		;   , 
rjmp GPS 	;  


_sleep:
;  
ldi R16,0x12	;clearLoRaIrq
ldi R17,0xff
rcall spi_write	;R16-,R17-
ldi R16,0x01	;sleep
ldi R17,0b10001000
rcall spi_write	;R16-,R17-
; , 
;   25
wdr				;  
ldi R16, 0b00110000;power down
out MCUCR, R16	;mode
nop
nop
sleep			;
nop
nop
nop
;-------------------------------------------------------------
;----------------  --------------------
;-------------------------------------------------------------
; UART
;PinGPS,data_gps-RX;R19-  
; R16/R17/R18/R19
uart_read:
sbic PinGPS,data_gps	;    "1"
rjmp uart_read	;   
;   .0 
;
ldi R16,36		;1bod
rcall delay_bod

; 
ldi R18,8		;.
circle_read:
ldi R16,3		;10
rcall delay_bod	;+10
clr R17
;+20
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
;30
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
;50
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
;70
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17

sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
sbic PinGPS,data_gps	;    "1"
inc R17
;sbic PinGPS,data_gps	;    "1"
;inc R17


;80
ldi R16,3		;10
rcall delay_bod	;+10
;78

lsr R19
cpi R17,20
brlo ne_1
ori R19, 0b10000000;sbiR/7
ne_1:
dec R18			;
breq _c
rjmp circle_read;+10
_c:
;R19  
;stop_bit
ldi R16,36		;1bod
delay_bod:
dec R16
brne delay_bod
ret


;     GPS
zapyataja:
rcall uart_read	; 
cpi R19,','		; ?
brne zapyataja	; ,
ret


;-  -
gps_nesw:
rcall uart_read	; 
rcall uart_read	;18.5
st Y+,R19
rcall uart_read	;1.8
st Y+,R19
rcall uart_read	;"."
rcall uart_read	;185
st Y+,R19
rcall uart_read	;18
st Y+,R19
rcall uart_read	;1.852
st Y+,R19
rcall zapyataja	;  
;rcall uart_read;  
;st Y+,R19		; N/S/E/W  
ret


;  R22*10=R22
x10:
ldi R16,10
clr R17
circle_x10:
add R17,R16
dec R22
brne circle_x10
mov R22,R17
ret


; LoRa, SPI
;R16-,R17-,R18-
spi_read:
cbi PortLoRa,lora_nss	;nSEL=0,start
cbi PortLoRa,lora_mosi	;sdi=0,"read"
	rcall spi			;  SPI
cbi PortLoRa,lora_mosi	;sdi=0
	clr R17		;
	ldi R18,8	;counter
adress_read:
sbi PortLoRa,lora_sck	;sclk=1
lsl R17					;move
sbic PinLoRa,lora_miso	;  SDO=1
inc R17					;+1
cbi PortLoRa,lora_sck	;sclk=0
dec R18		;8-
brne adress_read
sbi PortLoRa,lora_nss	;nSEL=1,end
ret


; SPI LoRa
;R16-,R17-,R18-
spi_write:
cbi PortLoRa,lora_nss	;nSEL=0,start
sbi PortLoRa,lora_mosi	;sdi=1,"write"
	rcall spi  	;  SPI
	ldi R18,8	;counter
data_write:
cbi PortLoRa,lora_mosi	;sdi=0
lsl R17			   	  	;move
brcc b_lo			  	;C=0, 
sbi PortLoRa,lora_mosi	;sdi=1
b_lo:
sbi PortLoRa,lora_sck	;sclk=1
dec R18					;8-
cbi PortLoRa,lora_sck	;sclk=0
brne data_write
sbi PortLoRa,lora_nss	;nSEL=1,end
ret


;,SPI LoRa
spi:
sbi PortLoRa,lora_sck	;sclk=1
lsl R16				 	;move
cbi PortLoRa,lora_sck	;sclk=0
	ldi R18,7	;counter
adress_write:
cbi PortLoRa,lora_mosi	;sdi=0
lsl R16				 	;move
brcc b_low			 	;C=0, 
sbi PortLoRa,lora_mosi	;sdi=1
b_low:
sbi PortLoRa,lora_sck	;sclk=1
dec R18 				;7-
cbi PortLoRa,lora_sck	;sclk=0
brne adress_write
ret


;  
lora_preconfig:
;***LoRa    sleep***
ldi R16,0x01
ldi R17,0b10001000
rcall spi_write	;R16-,R17-
rcall delay40mks
ldi R16,0x01	;stdby mode
ldi R17,0b10001001
rcall spi_write	;R16-,R17-
rcall delay40mks
;***R5R6R7-frequency***
ldi R16,0x06	;High
mov R17,R5
rcall spi_write	;R16-,R17-
ldi R16,0x07	;Mid
mov R17,R6
rcall spi_write	;R16-,R17-
ldi R16,0x08	;low
mov R17,R7
rcall spi_write	;R16-,R17-
; 
ldi R16,0x1d
ldi R17,0b01100011;62kHz,rate4/5,Implicit mode
;ldi R17,0b01101001;62kHz,rate4/8,Implicit mode
rcall spi_write	;R16-,R17-
; 
ldi R16,0x1e
;ldi R17,0b11000100;SF12
ldi R17,0b10110100;SF11
rcall spi_write	;R16-,R17-
;ModemConfig3
ldi R16,0x26
ldi R17,0b00001000;. 
rcall spi_write	;R16-,R17-
ret


;signal search
lora_search:
;  
ldi R16,0x12	;clearLoRaIrq
ldi R17,0xff
rcall spi_write	;R16-,R17-
ldi R16,0x01
ldi R17,0b10001111;CAD mode
rcall spi_write	;R16-,R17-
_ss:
rcall delay10ms	;  
ldi R16,0x12	;POH  LoRa
rcall spi_read	;R16-,R17-
sbrs R17,2		;if bitX,n='0' then do
rjmp _ss		;  
ret


;***TX mode ON***
lora_tx:
;  LNA -  
ldi R16,0x0c
ldi R17,0b11000000;min LNA gain
rcall spi_write	;R16-,R17-
;  
ldi R16,0x12	;clearLoRaIrq
ldi R17,0xff
rcall spi_write	;R16-,R17-
;  
ldi R16,0x01
ldi R17,0b10001011
rcall spi_write	;R16-,R17-
tx_wait:		;  
wdr				;
rcall delay10ms	;  
ldi R16,0x12
rcall spi_read	;R16-,R17-
sbrs R17, 3		;if bitX,n='0' then do
rjmp tx_wait
;  LNA -  
ldi R16,0x0c
ldi R17,0b00100000;default maxLNA gain
rcall spi_write	;R16-,R17-
ret

;***RX mode ON***
lora_rx:
;  
ldi R16,0x12	;clearLoRaIrq
ldi R17,0xff
rcall spi_write	;R16-,R17-
;   
ldi R16,0x01
ldi R17,0b10001110
rcall spi_write	;R16-,R17-
rx_wait:
wdr				;
rcall delay10ms	;  
ldi R16,0x12	;POH  LoRa
rcall spi_read	;R16-,R17-
sbrc R17, 7		;   timout
ret
sbrc R17, 6		;RX Dome
ret
rjmp rx_wait

;RSSI PowerTx 
lora_rssi:
ldi R16,0x1a	;RSSI last packet
rcall spi_read	;R16-,R17-
mov R11,R17
;  
ldi R16,0x8F	;100
_pwr_calc:
cpi R17,76		; RSSI
brlo _pwr_end
dec R16			;-1
dec R17			;-1
cpi R16,0x81
brsh _pwr_calc
_pwr_end:
mov R10,R16		; 
ret


;========Delay========
delay10ms:
ldi	R16, high(2500)
ldi R17, low(2500);20
rjmp delay
delay40mks:
ldi	R16, 0x00
ldi R17, 0x07	;42
delay:			;  x/4*hex
subi R17, 1 	;-1
sbci R16, 0 	;,'C'
brcc delay		;End delay(  'C')
ret
